#define WIN32_LEAN_AND_MEAN
#define _CRT_SECURE_NO_DEPRECATE
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "comport.h"

static HANDLE portHandle = NULL;

void comOpen(int port)
{
	if (portHandle == NULL) {
		char buf[100];
		sprintf(buf, "\\\\.\\COM%i", port);
		portHandle = CreateFile(buf, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL);
		DCB commDCB;
		memset(&commDCB, 0, sizeof (DCB));
		commDCB.DCBlength         = sizeof (DCB);
		commDCB.BaudRate          = CBR_115200;
		commDCB.fBinary           = TRUE;
		commDCB.fParity           = TRUE;
		commDCB.fDtrControl       = DTR_CONTROL_ENABLE;
		commDCB.fRtsControl       = RTS_CONTROL_DISABLE;
		commDCB.ByteSize          = 8;
		commDCB.Parity            = NOPARITY;
		commDCB.StopBits          = ONESTOPBIT;
		SetCommState(portHandle, &commDCB);
		COMMTIMEOUTS commTout;
		memset(&commTout, 0, sizeof(COMMTIMEOUTS));
		commTout.ReadIntervalTimeout         = MAXDWORD;
		commTout.ReadTotalTimeoutMultiplier  = 0;
		commTout.ReadTotalTimeoutConstant    = 0;
		commTout.WriteTotalTimeoutMultiplier = 1000;
		commTout.WriteTotalTimeoutConstant   = 1000;
		SetCommTimeouts(portHandle, &commTout);
		PurgeComm(portHandle, PURGE_RXCLEAR | PURGE_TXCLEAR | PURGE_RXABORT | PURGE_TXABORT);
	}
}

void comClose()
{
	if (portHandle) {
		CloseHandle(portHandle);
		portHandle = NULL;
	}
}

string comRead()
{
	string result = "";
	if (portHandle) {
		COMSTAT comstat;
		DWORD dwRead, dwError;
		char buf[256];
		dwRead = 0;
		ClearCommError(portHandle, &dwError, &comstat); // Get current comm status
		int toRead = comstat.cbInQue;
		if (toRead > 256) toRead = 256;
		if (toRead > 0) {
			if (ReadFile(portHandle, buf, toRead, &dwRead, NULL)) {
				for (DWORD i = 0; i < dwRead; i++) result += buf[i];
			}
		}
	}
	return result;
}

void comWrite(string text)
{
	if (portHandle) {
		DWORD dwWritten;
		WriteFile(portHandle, text.c_str(), (DWORD) text.length(), &dwWritten, NULL);
	}
}
