library IEEE;
use IEEE.STD_LOGIC_1164.ALL; 
use IEEE.NUMERIC_STD.ALL; 
--use work.ALL;

ENTITY cordic_testbench_vhd IS
END cordic_testbench_vhd;

ARCHITECTURE behavior OF cordic_testbench_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT CORDIC
	PORT(
		clock : IN std_logic;
		reset : IN std_logic;
		angle : IN unsigned(31 downto 0);
		newValueStrobe : IN std_logic;          
		sin : OUT signed(23 downto 0);
		cos : OUT signed(23 downto 0);
		sinCosReady : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL clock :  std_logic := '0';
	SIGNAL reset :  std_logic := '0';
	SIGNAL newValueStrobe :  std_logic := '0';
	SIGNAL angle :  unsigned(31 downto 0) := (others=>'0');

	--Outputs
	SIGNAL sin :  signed(23 downto 0);
	SIGNAL cos :  signed(23 downto 0);
	SIGNAL sinCosReady :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: CORDIC PORT MAP(
		clock => clock,
		reset => reset,
		angle => angle,
		newValueStrobe => newValueStrobe,
		sin => sin,
		cos => cos,
		sinCosReady => sinCosReady
	);

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 100 ns;

		-- start cordic calculation
        wait for 50 ns;
        newValueStrobe <= '1';
        angle <= x"00012345";
        wait for 50 ns;
        newValueStrobe <= '0';

		wait; -- will wait forever
	END PROCESS;

	update_clock: process
	begin
		while true loop 
			clock <= not clock;
			wait for 10 ns;
		end loop;
	end process;

END;
